function [res,u_res,D_res,g0_res,g1_res]=compare(D,g,i,del,u,d,a,l,c,r,q)
% compares old data to changed data and determines which results in a lower
% value

num=max(size(u));		% number of data points

% calculate new data point value and new D value
u_new = u(i)+del;
D_new = Dfun(d(i), u_new);
sum_new = D_new;
sum_old = D(i);

% calculate new g value (if statements needed to avoid passing
% out of array bounds
if(i~=1)
  g0_new = gfun(u_new, u(i-1), a, l, c, r, q);
  sum_new = sum_new+g0_new;
  sum_old = sum_old+g(i);
end
if(i~=num)
  g1_new = gfun(u(i+1), u_new, a, l, c, r, q);
  sum_new = sum_new+g1_new;
  sum_old = sum_old+g(i+1);
end

% store results based on the lower of the two sums
g0_res = 0;
g1_res = 0;
if (sum_new<sum_old)
  u_res = u_new;
  D_res = D_new;
  if(i~=1)
    g0_res = g0_new;
  end
  if(i~=num)
    g1_res = g1_new;
  end
  res=1;

else
  u_res = u(i);
  D_res = D(i);
  if(i~=1)
    g0_res = g(i);
  end
  if(i~=num)
    g1_res = g(i+1);
  end
  res=0;
end

